=== 3rdparty/edbee-lib/CMakeLists.txt ===
# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

PROJECT(edbee)

ADD_SUBDIRECTORY(edbee-lib)
ADD_SUBDIRECTORY(edbee-test)
