=== debian/changelog ===
mudlet (1:3.7.1-1.1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:50:47 +0100

mudlet (1:3.7.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Export CCACHE_DIR in debian/rules to prevent a FTBFS because of
    a non-writable cache directory.
  * QTabBar-include.patch: Fix FTBFS by adding the missing include for QTabBar.
    (Closes: #907159)

 -- Markus Koschany <apo@debian.org>  Sun, 09 Dec 2018 15:12:05 +0100

mudlet (1:3.7.1-1) unstable; urgency=medium

  * New upstream release
  * Update to standards 4.1.2

 -- Craig Small <csmall@debian.org>  Sun, 24 Dec 2017 17:49:23 +1100
