=== debian/watch ===
version=4

https://www.mudlet.org/download/ Mudlet-(.*)\.tar\.xz debian uupdate
